#include "farray.hpp"
#include <fstream.h>

template <class Iter>
void print(Iter begin, Iter end, const char* sep)
{
  for (Iter i=begin; i!=end; ++i)
    cout << *i << sep;
}
int main(void)
{
  fstream file("array.dat",ios::in|ios::out|ios::binary);
  size_t size=1000;
  
  FileArray<long double> arrd(file,size);
  streampos p = file.tellp();
  file << "hello" << endl;
  FileArray<int> arri(file,size);
  
  FileArray<unsigned> arrt(size);
  arrd[1] = 5.0;
  arrd[2] = 9.0;
  arrd[9] = 1.0;
  arrd[0]=-5.0/2;
  arrd[size-1]=-20;

  arri[1]=5;
  arri[2] = 9.0;
  arri[9] = 1.0;
  arri[0]=-5.0/2;
  arri[size-1]=-20;
  
  arrt[1]=5;
  arrt[2] = 9.0;
  arrt[9] = 1.0;
  arrt[0]=-5.0/2;
  arrt[size-1]=-20;
  
  cout << "arrd[1]=" << arrd[1] << endl;
  cout << "arrd[2]=" << arrd[2] << endl;
  cout << "arrd[9]=" << arrd[9] << endl;
  cout << "arrd[0]=" << arrd[0] << endl;
  cout << "arrd[2]=" << arrd[2] << endl;
  cout << "arrd[size-1])" << arrd[size-1] << endl;

  cout << "arri[1]=" << arri[1] << endl;
  cout << "arri[2]=" << arri[2] << endl;
  cout << "arri[9]=" << arri[9] << endl;
  cout << "arri[0]=" << arri[0] << endl;
  cout << "arri[2]=" << arri[2] << endl;
  cout << "arri[size-1])" << arri[size-1] << endl;

  print(arrt.begin(),arrt.begin()+3L, " ");
  cout << endl;
  cout << "arrt[1]=" << arrt[1] << endl;
  cout << "arrt[2]=" << arrt[2] << endl;
  cout << "arrt[9]=" << arrt[9] << endl;
  cout << "arrt[0]=" << arrt[0] << endl;
  cout << "arrt[2]=" << arrt[2] << endl;
  cout << "arrt[size-1])" << arrt[size-1] << endl;
  file.seekg(p);
  char word[10];
  file >> word;
  cout << word << endl;
}
